## openigtlink 3.0.0

=== CMakeLists.txt ===
PROJECT( OpenIGTLink )

cmake_minimum_required(VERSION 2.4)

if(COMMAND cmake_policy)
     cmake_policy(SET CMP0003 NEW)
     endif(COMMAND cmake_policy)

#-----------------------------------------------------------------------------
# OpenIGTlink version number.
SET(OpenIGTLink_VERSION_MAJOR "3")
SET(OpenIGTLink_VERSION_MINOR "0")
SET(OpenIGTLink_VERSION_PATCH "0")

option(OpenIGTLink_PROTOCOL_VERSION_2 "Build Library for Protocol Version 2" ON)
option(OpenIGTLink_PROTOCOL_VERSION_3 "Build Library for Protocol Version 3" ON)

SET(OpenIGTLink_HEADER_VERSION "1")
IF(OpenIGTLink_PROTOCOL_VERSION_3)
  SET(OpenIGTLink_PROTOCOL_VERSION "3")
  SET(OpenIGTLink_HEADER_VERSION "2")
ELSEIF(OpenIGTLink_PROTOCOL_VERSION_2)
  SET(OpenIGTLink_PROTOCOL_VERSION "2")
ELSE()
  SET(OpenIGTLink_PROTOCOL_VERSION "1")
ENDIF()


#-----------------------------------------------------------------------------
# OpenIGTLink build configuration options.

OPTION(BUILD_SHARED_LIBS "Build OpenIGTLink with shared libraries." OFF)
SET(OpenIGTLink_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

if(NOT OpenIGTLink_BUILD_SHARED_LIBS)
  OPTION(BUILD_GENERATE_PIC "Generate position independent code (for static)." ON)
  SET(OpenIGTLink_BUILD_GENERATE_PIC ${BUILD_GENERATE_PIC})
endif(NOT OpenIGTLink_BUILD_SHARED_LIBS)

OPTION(BUILD_EXAMPLES "Build OpenIGTLink example programs." OFF)
SET(OpenIGTLink_BUILD_EXAMPLES ${BUILD_EXAMPLES})

#-----------------------------------------------------------------------------
# Output directories.

IF(NOT LIBRARY_OUTPUT_PATH)
  SET (LIBRARY_OUTPUT_PATH ${OpenIGTLink_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET (EXECUTABLE_OUTPUT_PATH ${OpenIGTLink_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

SET(OpenIGTLink_LIBRARY_PATH "${LIBRARY_OUTPUT_PATH}")
SET(OpenIGTLink_EXECUTABLE_PATH "${EXECUTABLE_OUTPUT_PATH}")

SET(OpenIGTLink_CMAKE_DIR "${OpenIGTLink_SOURCE_DIR}/CMake")
SET(CMAKE_MODULE_PATH "${OpenIGTLink_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})

#-----------------------------------------------------------------------------
# Installation vars.
# OpenIGTLink_INSTALL_BIN_DIR          - binary dir (executables)
# OpenIGTLink_INSTALL_LIB_DIR          - library dir (libs)
# OpenIGTLink_INSTALL_DATA_DIR         - share dir (say, examples, data, etc)
# OpenIGTLink_INSTALL_INCLUDE_DIR      - include dir (headers)
# OpenIGTLink_INSTALL_PACKAGE_DIR      - package/export configuration files
# OpenIGTLink_INSTALL_NO_DEVELOPMENT   - do not install development files
# OpenIGTLink_INSTALL_NO_RUNTIME       - do not install runtime files
# OpenIGTLink_INSTALL_NO_DOCUMENTATION - do not install documentation files

IF(NOT OpenIGTLink_INSTALL_BIN_DIR)
  SET(OpenIGTLink_INSTALL_BIN_DIR "bin")
ENDIF(NOT OpenIGTLink_INSTALL_BIN_DIR)

IF(NOT OpenIGTLink_INSTALL_LIB_DIR)
  SET(OpenIGTLink_INSTALL_LIB_DIR "lib/igtl")
ENDIF(NOT OpenIGTLink_INSTALL_LIB_DIR)

IF(NOT OpenIGTLink_INSTALL_DATA_DIR)
  SET(OpenIGTLink_INSTALL_DATA_DIR "share/igtl")
ENDIF(NOT OpenIGTLink_INSTALL_DATA_DIR)

IF(NOT OpenIGTLink_INSTALL_INCLUDE_DIR)
  SET(OpenIGTLink_INSTALL_INCLUDE_DIR "include/igtl")
ENDIF(NOT OpenIGTLink_INSTALL_INCLUDE_DIR)

IF(NOT OpenIGTLink_INSTALL_PACKAGE_DIR)
  SET(OpenIGTLink_INSTALL_PACKAGE_DIR "${OpenIGTLink_INSTALL_LIB_DIR}/cmake/igtl-${OpenIGTLink_VERSION_MAJOR}.${OpenIGTLink_VERSION_MINOR}"
    CACHE INTERNAL "")
ENDIF(NOT OpenIGTLink_INSTALL_PACKAGE_DIR)

IF(NOT OpenIGTLink_INSTALL_NO_DOCUMENTATION)
  SET(OpenIGTLink_INSTALL_NO_DOCUMENTATION 0)
ENDIF(NOT OpenIGTLink_INSTALL_NO_DOCUMENTATION)

SET(OpenIGTLink_DIR "${CMAKE_BINARY_DIR}" CACHE INTERNAL "OpenIGTLink dir to be used by subprojects")

#-----------------------------------------------------------------------------
# Include directories

SET(OpenIGTLink_INCLUDE_DIRS_BUILD_TREE ${OpenIGTLink_INCLUDE_DIRS_BUILD_TREE}
  ${OpenIGTLink_BINARY_DIR}
  ${OpenIGTLink_SOURCE_DIR}/Source
  ${OpenIGTLink_SOURCE_DIR}/Source/igtlutil
)

INCLUDE_DIRECTORIES(
  ${OpenIGTLink_INCLUDE_DIRS_BUILD_TREE}
  )

#-----------------------------------------------------------------------------
# OpenIGTLink requires special compiler flags on some platforms.

INCLUDE (FindThreads)

IF(CMAKE_COMPILER_IS_GNUCXX)
  # '-fno-tree-vectorize' option is added to avoid segmentation fault that occurs in
  # igtl_image_convert_byte_order() (Source/igtlutil/igtl_image.c) built with 'Release'
  # option on 64-bit Linux.
  INCLUDE (CheckCXXCompilerFlag)
  CHECK_CXX_COMPILER_FLAG("-fno-tree-vectorize" OpenIGTLink_GNUCXX_TREE_VECTORIZE_SUPPORT)
  IF (OpenIGTLink_GNUCXX_TREE_VECTORIZE_SUPPORT)
    SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -w -fno-tree-vectorize")
    SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -ftemplate-depth-50 -fno-tree-vectorize")
  ENDIF (OpenIGTLink_GNUCXX_TREE_VECTORIZE_SUPPORT)

  # If the library is built as a static library, pass -fPIC option to the compiler
  IF(OpenIGTLink_BUILD_GENERATE_PIC)
    SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -fPIC")
    SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -fPIC")
  ENDIF(OpenIGTLink_BUILD_GENERATE_PIC)

  # pthread
  IF(CMAKE_HAVE_THREADS_LIBRARY)
    SET(OpenIGTLink_REQUIRED_LINK_FLAGS "${OpenIGTLink_REQUIRED_LINK_FLAGS} ${CMAKE_THREAD_LIBS_INIT}")
  ENDIF(CMAKE_HAVE_THREADS_LIBRARY)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)


# for the gnu compiler a -D_PTHREADS is needed on sun
# for the native compiler a -mt flag is needed on the sun
IF(CMAKE_USE_PTHREADS)
  IF(CMAKE_SYSTEM MATCHES "SunOS.*")
    IF(CMAKE_COMPILER_IS_GNUCXX)
      SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -D_PTHREADS")
    ELSE(CMAKE_COMPILER_IS_GNUCXX)
      SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -mt")
      SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -mt")
    ENDIF(CMAKE_COMPILER_IS_GNUCXX)
  ENDIF(CMAKE_SYSTEM MATCHES "SunOS.*")
ENDIF(CMAKE_USE_PTHREADS)


#-----------------------------------------------------------------------------
# Platform configuration tests.

# Socket tests etc.
INCLUDE(${OpenIGTLink_CMAKE_DIR}/OpenIGTLinkCMakeTests.cmake)

SET(OpenIGTLink_LIBRARY_TARGETS_FILE "${CMAKE_BINARY_DIR}/OpenIGTLinkTargets.cmake")

#-----------------------------------------------------------------------------
# Generate Configuration Header files.

include (${OpenIGTLink_SOURCE_DIR}/OpenIGTLinkConfigPlatform.cmake)

CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/igtlConfigure.h.in
  ${OpenIGTLink_BINARY_DIR}/igtlConfigure.h)

CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/igtl_typeconfig.h.in
  ${OpenIGTLink_BINARY_DIR}/igtl_typeconfig.h)

CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/igtlTypeConfig.h.in
  ${OpenIGTLink_BINARY_DIR}/igtlTypeConfig.h)

#-----------------------------------------------------------------------------
# Help other projects use OpenIGTLink.

# Copy the UseOpenIGTLink.cmake file to the binary tree for backward compatability.
CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/UseOpenIGTLink.cmake.in
${OpenIGTLink_BINARY_DIR}/UseOpenIGTLink.cmake COPYONLY IMMEDIATE)

# Create the OpenIGTLinkConfig.cmake file containing the OpenIGTLink configuration.
INCLUDE (${OpenIGTLink_SOURCE_DIR}/GenerateOpenIGTLinkConfig.cmake)

# Save the compiler settings so another project can import them.
INCLUDE(${CMAKE_ROOT}/Modules/CMakeExportBuildSettings.cmake)
CMAKE_EXPORT_BUILD_SETTINGS(${OpenIGTLink_BINARY_DIR}/OpenIGTLinkBuildSettings.cmake)

# Save library dependencies.
#EXPORT_LIBRARY_DEPENDENCIES(${OpenIGTLink_BINARY_DIR}/OpenIGTLinkLibraryDepends.cmake)

INSTALL(FILES
  ${OpenIGTLink_BINARY_DIR}/OpenIGTLinkBuildSettings.cmake
  ${OpenIGTLink_BINARY_DIR}/UseOpenIGTLink.cmake
  ${OpenIGTLink_BINARY_DIR}/Utilities/OpenIGTLinkConfig.cmake
  DESTINATION ${OpenIGTLink_INSTALL_PACKAGE_DIR}
  COMPONENT Development
  )

INSTALL(FILES
  ${OpenIGTLink_BINARY_DIR}/igtlConfigure.h
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
  COMPONENT Development
  )

INSTALL(FILES
  ${OpenIGTLink_BINARY_DIR}/igtl_typeconfig.h
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
  COMPONENT Development
  )

INSTALL(FILES
  ${OpenIGTLink_BINARY_DIR}/igtlTypeConfig.h
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
  COMPONENT Development
  )

#-----------------------------------------------------------------------------
# Add compiler flags OpenIGTLink needs to work on this platform.  This must be
# done AFTER the call to CMAKE_EXPORT_BUILD_SETTINGS.

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenIGTLink_REQUIRED_C_FLAGS}")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenIGTLink_REQUIRED_CXX_FLAGS}")
SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenIGTLink_REQUIRED_LINK_FLAGS}")
SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OpenIGTLink_REQUIRED_LINK_FLAGS}")
SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${OpenIGTLink_REQUIRED_LINK_FLAGS}")


#-----------------------------------------------------------------------------
# Configure Subdirectories

ADD_SUBDIRECTORY(Source)
ADD_SUBDIRECTORY(Tools)

IF(OpenIGTLink_BUILD_EXAMPLES)
 ADD_SUBDIRECTORY(Examples)
ENDIF(OpenIGTLink_BUILD_EXAMPLES)

#-----------------------------------------------------------------------------
# Export targets
export(TARGETS OpenIGTLink
  FILE "${OpenIGTLink_LIBRARY_TARGETS_FILE}"
  )

# Export targets for install
INSTALL(EXPORT OpenIGTLink
  DESTINATION "${OpenIGTLink_INSTALL_PACKAGE_DIR}"
  FILE "OpenIGTLinkTargets.cmake"
  )

#-----------------------------------------------------------------------------
# Tests
OPTION(BUILD_TESTING "Build the testing tree." ON)
SET(OpenIGTLink_BUILD_TESTING ${BUILD_TESTING})
IF(OpenIGTLink_BUILD_TESTING)
  ENABLE_TESTING()
  ADD_SUBDIRECTORY(Testing)
  INCLUDE (${CMAKE_ROOT}/Modules/Dart.cmake)
ENDIF()

#-----------------------------------------------------------------------------
# Doxygen

OPTION(BUILD_DOCUMENTATION "Build OpenIGTLink Documentation" OFF)

IF(BUILD_DOCUMENTATION)
  ADD_SUBDIRECTORY( Documents/Doxygen )
ENDIF(BUILD_DOCUMENTATION)

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)

#
# Examples
#


SET(EXAMPLE_DIRS
  Tracker
  Imager
  Status
  Receiver
  Thread
  )

if (${OpenIGTLink_PROTOCOL_VERSION} GREATER 1)
  SET(EXAMPLE_DIRS
    ${EXAMPLE_DIRS}
    ImageMeta
    Point
    TrackingData
    QuaternionTrackingData
    ImageDatabaseServer
    String
    Bind
    PolyData
    Capability
    Trajectory
    SessionManager
    )
endif (${OpenIGTLink_PROTOCOL_VERSION} GREATER 1)

## Imager program isn't supported by QNX
if(NOT OpenIGTLink_PLATFORM_QNX)
  SUBDIRS(
    ${EXAMPLE_DIRS}  
    )
else(NOT OpenIGTLink_PLATFORM_QNX)
  SUBDIRS(
      Tracker
      Status
      Receiver
      )
endif(NOT OpenIGTLink_PLATFORM_QNX)

=== Source/CMakeLists.txt ===
# list of libraries
# Note: this part should be moved to OpenIGTLinkConfigPlatform.cmake
IF(OpenIGTLink_PLATFORM_WIN32) # for Windows
  SET(LINK_LIBS
    ws2_32
    wsock32
    )

  #For debug under win32 system, the run time check mode should be set to /RTCu for multithreading purpose
  STRING(REPLACE "/RTC1" "/RTCu" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
  SET(OpenIGTLink_REQUIRED_CXX_FLAGS ${OpenIGTLink_REQUIRED_CXX_FLAGS})
ELSE() # for POSIX-compatible OSs
  SET(LINK_LIBS
    m
    pthread
    )
  IF(OpenIGTLink_PLATFORM_QNX)
    LIST(APPEND LINK_LIBS
      c
      socket
    )
  ENDIF()

  IF(OpenIGTLink_PLATFORM_SUNOS)
    LIST(APPEND LINK_LIBS
      ${OpenIGTLink_STD_LINK_LIBRARIES}
      )
  ENDIF()
ENDIF()

ADD_SUBDIRECTORY( igtlutil )

SET(OpenIGTLink_INCLUDE_DIRS
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/igtlutil
  ${CMAKE_CURRENT_BINARY_DIR}/igtlutil
  )

SET(OpenIGTLink_SOURCES
  igtlutil/igtl_header.c
  igtlutil/igtl_image.c
  igtlutil/igtl_transform.c
  igtlutil/igtl_status.c
  igtlutil/igtl_util.c
  igtlutil/igtl_position.c
  igtlutil/igtl_capability.c
  igtlClientSocket.cxx
  igtlCapabilityMessage.cxx
  igtlConditionVariable.cxx
  igtlFastMutexLock.cxx
  igtlImageMessage.cxx
  igtlImageMessage2.cxx
  igtlLightObject.cxx
  igtlMath.cxx
  igtlMessageBase.cxx
  igtlMessageFactory.cxx
  igtlMultiThreader.cxx
  igtlMutexLock.cxx
  igtlOSUtil.cxx
  igtlObject.cxx
  igtlObjectFactoryBase.cxx
  igtlPositionMessage.cxx
  igtlServerSocket.cxx
  igtlSessionManager.cxx
  igtlSimpleFastMutexLock.cxx
  igtlSocket.cxx
  igtlStatusMessage.cxx
  igtlTimeStamp.cxx
  igtlTransformMessage.cxx
  )

SET(OpenIGTLink_INCLUDE_FILES)
IF( MSVC OR ${CMAKE_GENERATOR} MATCHES "Xcode" )
  LIST(APPEND OpenIGTLink_INCLUDE_FILES
    igtlutil/igtl_header.h
    igtlutil/igtl_image.h
    igtlutil/igtl_position.h
    igtlutil/igtl_transform.h
    igtlutil/igtl_types.h
    igtlutil/igtl_util.h
    igtlutil/igtl_capability.h
    igtlutil/igtl_win32header.h
    igtlMessageHandler.h
    igtlMessageHandlerMacro.h
    igtlCapabilityMessage.h
    igtlClientSocket.h
    igtlConditionVariable.h
    igtlCreateObjectFunction.h
    igtlFastMutexLock.h
    igtlImageMessage.h
    igtlImageMessage2.h
    igtlLightObject.h
    igtlMacro.h
    igtlMath.h
    igtlMessageBase.h
    igtlMessageFactory.h
    igtlMessageHeader.h
    igtlMultiThreader.h
    igtlMutexLock.h
    igtlObjectFactory.h
    igtlOSUtil.h
    igtlObject.h
    igtlObjectFactoryBase.h
    igtlPositionMessage.h
    igtlServerSocket.h
    igtlSessionManager.h
    igtlSimpleFastMutexLock.h
    igtlSmartPointer.h
    igtlSocket.h
    igtlStatusMessage.h
    igtlTimeStamp.h
    igtlTransformMessage.h
    igtlTypes.h
    igtlWin32Header.h
    igtlWindows.h
    igtlCommon.h
  )
ENDIF()

# Add support for OpenIGTLink version 2
IF (${OpenIGTLink_PROTOCOL_VERSION} GREATER "1" )
  LIST(APPEND OpenIGTLink_SOURCES
    igtlutil/igtl_colortable.c
    igtlutil/igtl_imgmeta.c
    igtlutil/igtl_lbmeta.c
    igtlutil/igtl_point.c
    igtlutil/igtl_tdata.c
    igtlutil/igtl_qtdata.c
    igtlutil/igtl_trajectory.c
    igtlutil/igtl_unit.c
    igtlutil/igtl_sensor.c
    igtlutil/igtl_string.c
    igtlutil/igtl_ndarray.c
    igtlutil/igtl_bind.c
    igtlutil/igtl_qtrans.c
    igtlutil/igtl_polydata.c
    igtlColorTableMessage.cxx
    igtlImageMetaMessage.cxx
    igtlLabelMetaMessage.cxx
    igtlPointMessage.cxx
    igtlTrackingDataMessage.cxx
    igtlPolyDataMessage.cxx
    igtlQuaternionTrackingDataMessage.cxx
    igtlTrajectoryMessage.cxx
    igtlStringMessage.cxx
    igtlUnit.cxx
    igtlSensorMessage.cxx
    igtlBindMessage.cxx
    igtlNDArrayMessage.cxx
    )
  IF( MSVC OR ${CMAKE_GENERATOR} MATCHES "Xcode" )
    LIST(APPEND OpenIGTLink_INCLUDE_FILES
      igtlutil/igtl_colortable.h
      igtlutil/igtl_imgmeta.h
      igtlutil/igtl_lbmeta.h
      igtlutil/igtl_point.h
      igtlutil/igtl_tdata.h
      igtlutil/igtl_qtdata.h
      igtlutil/igtl_trajectory.h
      igtlutil/igtl_unit.h
      igtlutil/igtl_sensor.h
      igtlutil/igtl_string.h
      igtlutil/igtl_ndarray.h
      igtlutil/igtl_bind.h
      igtlutil/igtl_qtrans.h
      igtlutil/igtl_polydata.h
      igtlColorTableMessage.h
      igtlImageMetaMessage.h
      igtlLabelMetaMessage.h
      igtlPointMessage.h
      igtlTrackingDataMessage.h
      igtlPolyDataMessage.h
      igtlQuaternionTrackingDataMessage.h
      igtlTrajectoryMessage.h
      igtlStringMessage.h
      igtlUnit.h
      igtlSensorMessage.h
      igtlBindMessage.h
      igtlNDArrayMessage.h
      )
  ENDIF()
ENDIF()

# Add support for OpenIGTLink version 3
IF( ${OpenIGTLink_PROTOCOL_VERSION} GREATER "2" )
  LIST(APPEND OpenIGTLink_SOURCES
    igtlCommandMessage.cxx
    igtlQueryMessage.cxx
    igtlutil/igtl_command.c
    igtlutil/igtl_query.c
    )
  IF( MSVC OR ${CMAKE_GENERATOR} MATCHES "Xcode" )
    LIST(APPEND OpenIGTLink_INCLUDE_FILES
      igtlCommandMessage.h
      igtlQueryMessage.h
      igtlutil/igtl_command.h
      igtlutil/igtl_query.h
      )
  ENDIF()
ENDIF()

ADD_LIBRARY(OpenIGTLink ${OpenIGTLink_SOURCES} ${OpenIGTLink_INCLUDE_FILES})
foreach(p IN LISTS OpenIGTLink_INCLUDE_DIRS)
  target_include_directories(OpenIGTLink PUBLIC 
    $<BUILD_INTERFACE:${p}>)
endforeach()
target_include_directories(OpenIGTLink PUBLIC 
  $<INSTALL_INTERFACE:${OpenIGTLink_INSTALL_INCLUDE_DIR}>)

TARGET_LINK_LIBRARIES(OpenIGTLink PUBLIC ${LINK_LIBS})

IF(MSVC)
  target_compile_options(OpenIGTLink PRIVATE /MP)
ENDIF()

SET_TARGET_PROPERTIES(OpenIGTLink PROPERTIES
  VERSION ${OpenIGTLink_VERSION_MAJOR}.${OpenIGTLink_VERSION_MINOR}.${OpenIGTLink_VERSION_PATCH}
  SOVERSION ${OpenIGTLink_VERSION_MAJOR}
  )

INSTALL(FILES ${OpenIGTLink_INCLUDE_FILES}
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
  COMPONENT Development)

INSTALL(TARGETS OpenIGTLink EXPORT OpenIGTLink
  RUNTIME DESTINATION ${OpenIGTLink_INSTALL_BIN_DIR} COMPONENT RuntimeLibraries
  LIBRARY DESTINATION ${OpenIGTLink_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${OpenIGTLink_INSTALL_LIB_DIR} COMPONENT Development)

=== Testing/CMakeLists.txt ===
PROJECT( OpenIGTLinkTesting )

cmake_minimum_required(VERSION 2.9)
find_package(OpenIGTLink REQUIRED)
include(${OpenIGTLink_USE_FILE})
include_directories(${OpenIGTLink_INCLUDE_DIRS})
link_directories(${OpenIGTLink_LIBRARY_DIRS})
include_directories(${PROJECT_BINARY_DIR})
OPTION(USE_GTEST "Build the testing tree." ON)
IF(USE_GTEST)
	SET(OpenIGTLink_USE_GTEST "1")
ELSE()
  SET(OpenIGTLink_USE_GTEST "0")
ENDIF()	
configure_file(${PROJECT_SOURCE_DIR}/igtlTestConfig.h.in ${PROJECT_BINARY_DIR}/igtlTestConfig.h)
ENABLE_TESTING()
ADD_SUBDIRECTORY( igtlutil )
IF(OpenIGTLink_USE_GTEST)
	#-----------
	#download of GoogleTest
	if( MSVC ) # VS2012 doesn't support correctly the tuples yet
		add_definitions("-D_VARIADIC_MAX=10")
	endif()
	# Download and unpack googletest at configure time
	configure_file(CMakeLists.txt.in
								 googletest-download/CMakeLists.txt)
	execute_process(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" . 
		WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/googletest-download" )

	execute_process(COMMAND "${CMAKE_COMMAND}" --build . 
		WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/googletest-download" )

	# Prevent GoogleTest from overriding our compiler/linker options
	# when building with Visual Studio
	set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

	# Add googletest directly to our build. This adds
	# the following targets: gtest, gtest_main, gmock
	# and gmock_main
	add_subdirectory("${PROJECT_BINARY_DIR}/gmock"
									 "${PROJECT_BINARY_DIR}/gmock-build" )

	# The gtest/gmock targets carry header search path
	# dependencies automatically when using CMake 2.8.11 or
	# later. Otherwise we have to add them here ourselves.
	include_directories("${gtest_SOURCE_DIR}/include")
	include_directories("${gmock_SOURCE_DIR}/include")
#---------------
ENDIF()

ADD_EXECUTABLE(igtlMultiThreaderTest1   igtlMultiThreaderTest1.cxx)
ADD_EXECUTABLE(igtlMultiThreaderTest2   igtlMultiThreaderTest2.cxx)
ADD_EXECUTABLE(igtlMultiThreaderTest3   igtlMultiThreaderTest3.cxx)
ADD_EXECUTABLE(igtlMessageFactoryTest   igtlMessageFactoryTest.cxx)
ADD_EXECUTABLE(igtlTimeStampTest1   igtlTimeStampTest1.cxx)
ADD_EXECUTABLE(igtlMessageBaseTest   igtlMessageBaseTest.cxx)
ADD_EXECUTABLE(igtlConditionVariableTest   igtlConditionVariableTest.cxx)

ADD_EXECUTABLE(igtlImageMessageTest   igtlImageMessageTest.cxx)
ADD_EXECUTABLE(igtlImageMessage2Test   igtlImageMessage2Test.cxx)
ADD_EXECUTABLE(igtlTransformMessageTest   igtlTransformMessageTest.cxx)
ADD_EXECUTABLE(igtlPositionMessageTest   igtlPositionMessageTest.cxx)
ADD_EXECUTABLE(igtlStatusMessageTest   igtlStatusMessageTest.cxx)
ADD_EXECUTABLE(igtlCapabilityMessageTest   igtlCapabilityMessageTest.cxx)

#ADD_EXECUTABLE(igtlSocketTest         igtlSocketTest.cxx)
#ADD_EXECUTABLE(igtlServerSocketTest   igtlServerSocketTest.cxx)
#ADD_EXECUTABLE(igtlClientSocketTest   igtlClientSocketTest.cxx)

# Message Tests Added in Version 2
IF(${OpenIGTLink_PROTOCOL_VERSION} GREATER "1")
  ADD_EXECUTABLE(igtlBindMessageTest   igtlBindMessageTest.cxx)
  ADD_EXECUTABLE(igtlColorTableMessageTest   igtlColorTableMessageTest.cxx)
  ADD_EXECUTABLE(igtlLabelMetaMessageTest   igtlLabelMetaMessageTest.cxx)
  ADD_EXECUTABLE(igtlNDArrayMessageTest   igtlNDArrayMessageTest.cxx)
  ADD_EXECUTABLE(igtlImageMetaMessageTest   igtlImageMetaMessageTest.cxx)
  ADD_EXECUTABLE(igtlPointMessageTest   igtlPointMessageTest.cxx)
  ADD_EXECUTABLE(igtlPolyDataMessageTest   igtlPolyDataMessageTest.cxx)
  ADD_EXECUTABLE(igtlSensorMessageTest   igtlSensorMessageTest.cxx)
  ADD_EXECUTABLE(igtlStringMessageTest   igtlStringMessageTest.cxx)
  ADD_EXECUTABLE(igtlTrackingDataMessageTest   igtlTrackingDataMessageTest.cxx)
  ADD_EXECUTABLE(igtlTrajectoryMessageTest   igtlTrajectoryMessageTest.cxx)
ENDIF()

# Message Tests Added in Version 3
IF(${OpenIGTLink_PROTOCOL_VERSION} GREATER "2")
  ADD_EXECUTABLE(igtlCommandMessageTest   igtlCommandMessageTest.cxx)
ENDIF()


IF(USE_GTEST)
  SET(GTEST_LINK OpenIGTLink gtest_main gtest gmock_main gmock)
ELSE()
  SET(GTEST_LINK OpenIGTLink)
ENDIF()
  
TARGET_LINK_LIBRARIES(igtlMultiThreaderTest1 OpenIGTLink)
TARGET_LINK_LIBRARIES(igtlMultiThreaderTest2 OpenIGTLink)
TARGET_LINK_LIBRARIES(igtlMultiThreaderTest3 OpenIGTLink)
TARGET_LINK_LIBRARIES(igtlMessageFactoryTest OpenIGTLink)
TARGET_LINK_LIBRARIES(igtlTimeStampTest1 OpenIGTLink)
TARGET_LINK_LIBRARIES(igtlMessageBaseTest ${GTEST_LINK})
TARGET_LINK_LIBRARIES(igtlConditionVariableTest ${GTEST_LINK})

TARGET_LINK_LIBRARIES(igtlImageMessageTest ${GTEST_LINK})
TARGET_LINK_LIBRARIES(igtlImageMessage2Test ${GTEST_LINK})
TARGET_LINK_LIBRARIES(igtlCapabilityMessageTest ${GTEST_LINK})
TARGET_LINK_LIBRARIES(igtlStatusMessageTest ${GTEST_LINK})
TARGET_LINK_LIBRARIES(igtlTransformMessageTest ${GTEST_LINK})
TARGET_LINK_LIBRARIES(igtlPositionMessageTest ${GTEST_LINK})

# Message Tests Added in Version 2
IF(${OpenIGTLink_PROTOCOL_VERSION} GREATER "1")
  TARGET_LINK_LIBRARIES(igtlBindMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlColorTableMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlLabelMetaMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlNDArrayMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlImageMetaMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlPointMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlPolyDataMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlSensorMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlStringMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlTrackingDataMessageTest ${GTEST_LINK})
  TARGET_LINK_LIBRARIES(igtlTrajectoryMessageTest ${GTEST_LINK})
ENDIF()

# Message Tests Added in Version 3
IF(${OpenIGTLink_PROTOCOL_VERSION} GREATER "2")
  TARGET_LINK_LIBRARIES(igtlCommandMessageTest ${GTEST_LINK})
ENDIF()


#TARGET_LINK_LIBRARIES(igtlSocketTest ${GTEST_LINK})
#TARGET_LINK_LIBRARIES(igtlClientSocketTest ${GTEST_LINK})
#TARGET_LINK_LIBRARIES(igtlServerSocketTest ${GTEST_LINK})

set(TestStringFormat1 "--gtest_filter=*.*FormatVersion1")

ADD_TEST(igtlMultiThreaderTest1 ${OpenIGTLink_EXECUTABLE_PATH}/igtlMultiThreaderTest1)
ADD_TEST(igtlMultiThreaderTest2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlMultiThreaderTest2)
ADD_TEST(igtlMultiThreaderTest3 ${OpenIGTLink_EXECUTABLE_PATH}/igtlMultiThreaderTest3)
ADD_TEST(igtlMessageFactoryTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlMessageFactoryTest)
ADD_TEST(igtlTimeStampTest1 ${OpenIGTLink_EXECUTABLE_PATH}/igtlTimeStampTest1)
ADD_TEST(igtlMessageBaseTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlMessageBaseTest ${TestStringFormat1})
ADD_TEST(igtlConditionVariableTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlConditionVariableTest ${TestStringFormat1})

ADD_TEST(igtlImageMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlImageMessageTest ${TestStringFormat1})
ADD_TEST(igtlImageMessage2Test ${OpenIGTLink_EXECUTABLE_PATH}/igtlImageMessage2Test ${TestStringFormat1})
ADD_TEST(igtlCapabilityMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlCapabilityMessageTest ${TestStringFormat1})
ADD_TEST(igtlStatusMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlStatusMessageTest ${TestStringFormat1})
ADD_TEST(igtlTransformMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlTransformMessageTest ${TestStringFormat1})
ADD_TEST(igtlPositionMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlPositionMessageTest ${TestStringFormat1})


# Message Tests Added in Version 2
IF(${OpenIGTLink_PROTOCOL_VERSION} GREATER "1")
  ADD_TEST(igtlBindMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlBindMessageTest ${TestStringFormat1})
  ADD_TEST(igtlColorTableMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlColorTableMessageTest ${TestStringFormat1})
  ADD_TEST(igtlLabelMetaMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlLabelMetaMessageTest ${TestStringFormat1})
  ADD_TEST(igtlNDArrayMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlNDArrayMessageTest ${TestStringFormat1})
  ADD_TEST(igtlImageMetaMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlLabelMetaMessageTest ${TestStringFormat1})
  ADD_TEST(igtlPointMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlPointMessageTest ${TestStringFormat1})
  ADD_TEST(igtlPolyDataMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlPolyDataMessageTest ${TestStringFormat1})
  ADD_TEST(igtlSensorMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlSensorMessageTest ${TestStringFormat1})
  ADD_TEST(igtlStringMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlStringMessageTest ${TestStringFormat1})
  ADD_TEST(igtlTrackingDataMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlTrackingDataMessageTest ${TestStringFormat1})
  ADD_TEST(igtlTrajectoryMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlTrajectoryMessageTest ${TestStringFormat1})
ENDIF()

# Message Tests Added in Version 3
IF(${OpenIGTLink_PROTOCOL_VERSION} GREATER "2")
  set(TestStringFormat2 "--gtest_filter=*.*FormatVersion2")
  ADD_TEST(igtlMessageBaseTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlMessageBaseTest ${TestStringFormat2})
  ADD_TEST(igtlImageMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlImageMessageTest ${TestStringFormat2})
  ADD_TEST(igtlImageMessage2TestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlImageMessage2Test ${TestStringFormat2})
  ADD_TEST(igtlBindMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlBindMessageTest ${TestStringFormat2})
  ADD_TEST(igtlCapabilityMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlCapabilityMessageTest ${TestStringFormat2})
  ADD_TEST(igtlColorTableMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlColorTableMessageTest ${TestStringFormat2})
  ADD_TEST(igtlConditionVariableTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlConditionVariableTest ${TestStringFormat2})
  ADD_TEST(igtlLabelMetaMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlLabelMetaMessageTest ${TestStringFormat2})
  ADD_TEST(igtlNDArrayMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlNDArrayMessageTest ${TestStringFormat2})
  ADD_TEST(igtlImageMetaMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlLabelMetaMessageTest ${TestStringFormat2})
  ADD_TEST(igtlPointMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlPointMessageTest ${TestStringFormat2})
  ADD_TEST(igtlPolyDataMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlPolyDataMessageTest ${TestStringFormat2})
  ADD_TEST(igtlSensorMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlSensorMessageTest ${TestStringFormat2})
  ADD_TEST(igtlStatusMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlStatusMessageTest ${TestStringFormat2})
  ADD_TEST(igtlStringMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlStringMessageTest ${TestStringFormat2})
  ADD_TEST(igtlTrackingDataMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlTrackingDataMessageTest ${TestStringFormat2})
  ADD_TEST(igtlTrajectoryMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlTrajectoryMessageTest ${TestStringFormat2})
  ADD_TEST(igtlTransformMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlTransformMessageTest ${TestStringFormat2})
  ADD_TEST(igtlPositionMessageTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlPositionMessageTest)
  ADD_TEST(igtlCommandMessageTestFormatVersion1 ${OpenIGTLink_EXECUTABLE_PATH}/igtlCommandMessageTest ${TestStringFormat1})
  ADD_TEST(igtlCommandMessageTestFormatVersion2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlCommandMessageTest ${TestStringFormat2})
ENDIF()

=== Tools/CMakeLists.txt ===
#
#  Add here Tools that provide OpenIGTLink functionalities.
#

=== Documents/Doxygen/CMakeLists.txt ===
#-- Add an Option to toggle the generation of the API documentation
if(BUILD_DOCUMENTATION)

  FIND_PACKAGE(Doxygen QUIET)
  if (NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation. Please install it correctly")
  endif()

  #IF (BUILD_DOXYGEN)
    CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/Utilities/Doxygen/doxygen.config.in
                 ${OpenIGTLink_BINARY_DIR}/Utilities/Doxygen/doxygen.config)

    CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/Utilities/Doxygen/igtldoxygen.pl.in
                 ${OpenIGTLink_BINARY_DIR}/Utilities/Doxygen/igtldoxygen.pl)
    
    ADD_CUSTOM_TARGET(Documentation 
      COMMAND ${DOXYGEN_EXECUTABLE} ${OpenIGTLink_BINARY_DIR}/Utilities/Doxygen/doxygen.config
      MAIN_DEPENDENCY ${OpenIGTLink_BINARY_DIR}/Utilities/Doxygen/doxygen.config
      DEPENDS         ${OpenIGTLink_BINARY_DIR}/Utilities/Doxygen/igtldoxygen.pl
      WORKING_DIRECTORY ${OpenIGTLink_BINARY_DIR}/Utilities/Doxygen
      )
  #ENDIF (BUILD_DOXYGEN)

endif()

=== Examples/Capability/CMakeLists.txt ===
PROJECT(Capability)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(CapabilityClient   CapabilityClient.cxx)
TARGET_LINK_LIBRARIES(CapabilityClient OpenIGTLink)

ADD_EXECUTABLE(CapabilityServer   CapabilityServer.cxx)
TARGET_LINK_LIBRARIES(CapabilityServer OpenIGTLink)

=== Examples/ImageDatabaseServer/CMakeLists.txt ===
PROJECT(ImageDatabaseServer)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})


## igtl::ImageDatabaseMessage examples
ADD_EXECUTABLE(ImageDatabaseServer   ImageDatabaseServer.cxx)
TARGET_LINK_LIBRARIES(ImageDatabaseServer OpenIGTLink)

=== Examples/ImageMeta/CMakeLists.txt ===
PROJECT(ImageMeta)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})


## igtl::ImageMetaMessage examples
ADD_EXECUTABLE(ImageMetaServer   ImageMetaServer.cxx)
TARGET_LINK_LIBRARIES(ImageMetaServer OpenIGTLink)

ADD_EXECUTABLE(ImageMetaClient   ImageMetaClient.cxx)
TARGET_LINK_LIBRARIES(ImageMetaClient OpenIGTLink)

## igtl::LabelMetaMessage example
ADD_EXECUTABLE(LabelMetaServer   LabelMetaServer.cxx)
TARGET_LINK_LIBRARIES(LabelMetaServer OpenIGTLink)

ADD_EXECUTABLE(LabelMetaClient   LabelMetaClient.cxx)
TARGET_LINK_LIBRARIES(LabelMetaClient OpenIGTLink)

=== Examples/Imager/CMakeLists.txt ===
PROJECT(Imager)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(ImagerClient   ImagerClient.cxx)
TARGET_LINK_LIBRARIES(ImagerClient OpenIGTLink)

ADD_EXECUTABLE(ImagerClient2   ImagerClient2.cxx)
TARGET_LINK_LIBRARIES(ImagerClient2 OpenIGTLink)

ADD_EXECUTABLE(ImagerServer   ImagerServer.cxx)
TARGET_LINK_LIBRARIES(ImagerServer OpenIGTLink)

ADD_EXECUTABLE(ImagerClient3   ImagerClient3.cxx)
TARGET_LINK_LIBRARIES(ImagerClient3 OpenIGTLink)

ADD_EXECUTABLE(ImagerServer3   ImagerServer3.cxx)
TARGET_LINK_LIBRARIES(ImagerServer3 OpenIGTLink)

=== Examples/Point/CMakeLists.txt ===
PROJECT(Point)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(PointClient   PointClient.cxx)
TARGET_LINK_LIBRARIES(PointClient OpenIGTLink)

ADD_EXECUTABLE(PointServer   PointServer.cxx)
TARGET_LINK_LIBRARIES(PointServer OpenIGTLink)

ADD_EXECUTABLE(PointListServer   PointListServer.cxx)
TARGET_LINK_LIBRARIES(PointListServer OpenIGTLink)

ADD_EXECUTABLE(PointClient3   PointClient3.cxx)
TARGET_LINK_LIBRARIES(PointClient3 OpenIGTLink)

ADD_EXECUTABLE(PointServer3   PointServer3.cxx)
TARGET_LINK_LIBRARIES(PointServer3 OpenIGTLink)

=== Examples/Receiver/CMakeLists.txt ===
PROJECT(Receiver)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(ReceiveServer  ReceiveServer.cxx)
TARGET_LINK_LIBRARIES(ReceiveServer OpenIGTLink)

ADD_EXECUTABLE(ReceiveClient  ReceiveClient.cxx)
TARGET_LINK_LIBRARIES(ReceiveClient OpenIGTLink)

=== debian/changelog ===
openigtlink (3.0.0-3) unstable; urgency=medium

  * debian/rules: remove hard-coded -DCMAKE_BUILD_TYPE
  * debian/control: declare Rules-Requires-Root: no

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 06 Sep 2025 02:03:45 -0400

openigtlink (3.0.0-2) unstable; urgency=medium

  * Fix FTBFS with CMake 4 (Closes: #1113357)
  * openigtlink 3.0 fixes socket close issue (Closes: #1010511)

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 05 Sep 2025 15:56:03 -0400

openigtlink (3.0.0-1) unstable; urgency=medium

  * New upstream release.
  * SONAME bump from 1.11 to 3.0
  * update debian/patches

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 16 May 2025 11:57:45 -0400

openigtlink (1.11.0-6) unstable; urgency=medium

  * debhelper-compat 13
  * Update Standards version to 4.7.2
  * Move from CDBS to debhelper (Closes: #1099947)
  * fix invalid short license name
  * update copyright-format fields

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 05 May 2025 11:50:04 -0400

openigtlink (1.11.0-5) unstable; urgency=medium

  * Team upload.
  * Reformat d/control with debputy
  * Fix Team name

  [ Jelmer Vernooĳ ]
  * Use correct machine-readable copyright file URI.

  [ Debian Janitor ]
  * Apply multi-arch hints. + openigtlink-doc, openigtlink-examples: Add Multi-Arch: foreign.

 -- Alexandre Detiste <tchet@debian.org>  Mon, 21 Apr 2025 20:01:58 +0200

openigtlink (1.11.0-4) unstable; urgency=medium

  * Team upload.
  * Move packaging from SVN to Git
  * cme fix dpkg-control
  * Remove quilt from Build-Depends (not needed for source/format 3.0 (quilt))
  * Drop manual -dbg package
  * Delete useless autogenerated doxygen files

 -- Andreas Tille <tille@debian.org>  Tue, 23 Jan 2018 16:52:38 +0100

openigtlink (1.11.0-3) unstable; urgency=medium

  * Update debian/watch file
  * Fix lintian error: privacy-breach-logo
  * Fix: Update to Debian Policy 3.9.8 (no changes)

 -- Dominique Belhachemi <domibel@debian.org>  Sun, 23 Apr 2017 18:02:48 -0400

openigtlink (1.11.0-2) unstable; urgency=medium

  * added reproducible_build.patch (Closes: #860278)
  * added gcc7.patch (Closes: 853591)
  * Update to Debian Policy 3.9.8 (no changes)

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 14 Apr 2017 22:30:07 -0400

=== debian/control ===
Source: openigtlink
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Dominique Belhachemi <domibel@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Build-Depends-Indep:
 doxygen-latex,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/openigtlink
Vcs-Git: https://salsa.debian.org/science-team/openigtlink.git
Homepage: http://openigtlink.org
Rules-Requires-Root: no
X-Style: black

Package: libopenigtlink-dev
Architecture: any
Section: libdevel
Depends:
 libopenigtlink3.0 (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libopenigtlink1-dev (<< 1.10.4~git20131104+3ac531115f-2),
Replaces:
 libopenigtlink1-dev (<< 1.10.4~git20131104+3ac531115f-2),
Description: Open IGT Link is a simple network protocol - development
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 For example applications may include:
  * Stereotactic surgical guidance using optical position sensor and
    medical image visualization software.
  * Intraoperative image guidance using real-time MRI and medical image
    visualization software
  * Robot-assisted intervention using robotic device and surgical planning
    software
 .
 This package contains the development files needed to build
 your own IGT applications.

Package: libopenigtlink3.0
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open IGT Link is a simple network protocol - runtime
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 For example applications may include:
  * Stereotactic surgical guidance using optical position sensor and
    medical image visualization software.
  * Intraoperative image guidance using real-time MRI and medical image
    visualization software
  * Robot-assisted intervention using robotic device and surgical planning
    software
 .
 This package contains library files for OpenIGTLink.

Package: openigtlink-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Multi-Arch: foreign
Description: Open IGT Link is a simple network protocol - documentation
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 For example applications may include:
  * Stereotactic surgical guidance using optical position sensor and
    medical image visualization software.
  * Intraoperative image guidance using real-time MRI and medical image
    visualization software
  * Robot-assisted intervention using robotic device and surgical planning
    software
 .
 This package contains documentation files for OpenIGTLink.

Package: openigtlink-examples
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 libopenigtlink-dev,
Multi-Arch: foreign
Description: Open IGT Link is a simple network protocol - examples
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 For example applications may include:
  * Stereotactic surgical guidance using optical position sensor and
    medical image visualization software.
  * Intraoperative image guidance using real-time MRI and medical image
    visualization software
  * Robot-assisted intervention using robotic device and surgical planning
    software
 .
 This package contains examples from the OpenIGTLink source.
 .
 Consult /usr/share/doc/libopenigtlink-dev/README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f

# Set this value to 0/1 to turn off/on verbose mode.
#export DH_VERBOSE=1

ABI_VERSION := 3.0

BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)

CMAKE_EXTRA_FLAGS = \
        -DCMAKE_SKIP_RPATH:BOOL=ON \
        -DBUILD_SHARED_LIBS:BOOL=ON \
        -DBUILD_DOCUMENTATION:BOOL=ON \
        -DBUILD_TESTING:BOOL=ON \
        -DBUILD_EXAMPLES:BOOL=OFF \
        -DUSE_GTEST:BOOL=OFF \
	-DOpenIGTLink_PROTOCOL_VERSION_3:BOOL=ON \
	-DOpenIGTLink_INSTALL_LIB_DIR:PATH=lib \
	-DOpenIGTLink_INSTALL_DATA_DIR:PATH=share/openigtlink \
	-DOpenIGTLink_INSTALL_INCLUDE_DIR:PATH=include/openigtlink \
	-DOpenIGTLink_INSTALL_PACKAGE_DIR:PATH=lib/cmake/openigtlink

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	mkdir -p $(BUILDDIR)/Documents/Doxygen
	doxygen -u $(BUILDDIR)/Utilities/Doxygen/doxygen.config
	doxygen $(BUILDDIR)/Utilities/Doxygen/doxygen.config

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel -- LD_LIBRARY_PATH="$(CURDIR)/$(BUILDDIR)/bin:$$LD_LIBRARY_PATH"
else
	@echo "Skipping tests due to DEB_BUILD_OPTIONS=nocheck"
endif

override_dh_auto_test-indep:
	@echo "Skipping tests for arch-independent build."

override_dh_auto_install-arch:
	dh_auto_install

override_dh_auto_install-indep:
	@echo "Skipping auto install for arch-independent build."

override_dh_install-arch:
	dh_install -plibopenigtlink${ABI_VERSION}    debian/tmp/usr/lib/*.so.*              usr/lib
	dh_install -plibopenigtlink-dev      debian/tmp/usr/include/openigtlink/*           usr/include/openigtlink
	dh_install -plibopenigtlink-dev      debian/tmp/usr/lib/*.so                        usr/lib
	dh_install -plibopenigtlink-dev      debian/tmp/usr/lib/cmake/openigtlink/*.cmake   usr/lib/cmake/openigtlink

override_dh_install-indep:
	dh_install -popenigtlink-doc $(BUILDDIR)/Documents/Doxygen/html usr/share/doc/openigtlink-doc
	dh_installexamples -popenigtlink-examples Examples/*


get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/OpenIGTLink-$1\.tar\.gz/ \
  https://github.com/openigtlink/OpenIGTLink/tags .*/v?(\d\S+)\.tar\.gz
